% -------------------------------------------------------------------------
function [F,F2] = MNLllc(Y,X,alpha,beta,betaLc)
% -------------------------------------------------------------------------
J       = size(Y,2);
Lc      = size(betaLc,2);
F       = zeros(J-1,Lc);
F2      = zeros(J-1,Lc);

xb      = X*beta;
sYxb    = sum(Y.*xb);
ssYaxb  = sum(sYxb+sum(Y).*alpha');
xbc     = X*betaLc;
ssYxbc  = Y'*xbc;

eaxb    = exp(alpha'+xb);
seaxb   = sum(eaxb,2);
exbc    = exp(xbc);
ea      = exp(alpha);
% -------------------------------------------------------------------------
for l=1:Lc
    for j=2:J % do not need to look at all combinations.
        l1           = ssYaxb-sYxb(1,j)+ssYxbc(j,l);
        sexbjl       = seaxb-eaxb(:,j)+exbc(:,l)*ea(j);
        l2           = sum(log(sexbjl));
        F(j-1,l)     = l1-l2;
%         betalj=beta;
%         betalj(:,j)=betaLc(:,l);
%         axb    = alpha'+X*betalj;
%         expaxb = exp(axb);
%         l11    = sum(sum(Y.*axb));
%         l22    = sum(log(sum(expaxb,2)));
%         F2(j-1,l)     = l11-l22;
    end
end
% -------------------------------------------------------------------------
end