% -------------------------------------------------------------------------
function F = MNLllc(Y,X,alpha,beta,betaLc)
% -------------------------------------------------------------------------
J       = size(Y,2);
Lc      = size(betaLc,2);
F       = zeros(J,Lc);
% -------------------------------------------------------------------------
xb      = X*beta;
sYxb    = sum(Y.*xb);
ssYaxb  = sum(sYxb+sum(Y.*alpha)); 
xbc     = X*betaLc;
ssYxbc  = Y'*xbc;
% -------------------------------------------------------------------------
eaxb    = exp(alpha+xb);
seaxb   = 1+sum(eaxb,2);
exbc    = exp(xbc);
ea      = exp(alpha);
% -------------------------------------------------------------------------
for j=1:J
    l1           = ssYaxb-sYxb(1,j);
    sexbj        = seaxb-eaxb(:,j);
    l2           = sum(log(sexbj+ea(:,j)));
    F(j,1)       = l1-l2;
    for l=2:Lc
        l2           = sum(log(sexbj+exbc(:,l).*ea(:,j)));
        F(j,l)       = l1+ssYxbc(j,l)-l2;
    end
end
% -------------------------------------------------------------------------
end
% -------------------------------------------------------------------------


% Sigma = B*B'+diag(d.^2);
% 
% 
% dm2 = diag(invpsi);
%     Sigma_inv = dm2-dm2*Lambda*Lambda'*dm2/(1+Lambda'*dm2*Lambda);
% 
%     Sigma_inv = dm2-(Lambda.*invpsi)*(Lambda.*invpsi)'/(1+Lambda'*dm2*Lambda)