% Pk = zeros(5,10);
% alpha=1;
% for n=1:5
%    for k=1:10
%        T=n*100;
%       logst  = unsStirling1(T,T^(.75));
%       Pk(n,k)=exp(logst(k)+k*log(alpha)+gammaln(alpha)-gammaln(alpha+T));
%    end
% end
% 
% -------------------------------------------------------------------------


% logst   = unsStirling1(T,T^(.75));
% Pk(n,k) = exp(logst(k)+k*log(alpha)+gammaln(alpha)-gammaln(alpha+T));
% 
% 
function [E,V,p] = alpha2num(prior,N,Imax,M)
P = zeros(M,Imax);
for m=1:M
    alpha      = gamrnd(prior.eta1,1/prior.eta2);
    logst      = unsStirling1(N,N^(.75));
    for i =1:Imax
    P(m,i)     = exp(logst(i)+i*log(alpha)+gammaln(alpha)-gammaln(alpha+N));
    end
end
p = mean(P);
E = sum(p.*(1:Imax));
V = sum(p.*(((1:Imax)-E).^2));
end
% -------------------------------------------------------------------------


