function [Yin,kappa,Xin,Xw,Xd,Yout,Xout]= app_data()
% -------------------------------------------------------------------------
load DatasetNold_date.mat X Ydest;
% -------------------------------------------------------------------------
Y         = dummyvar(Ydest);
N         = size(Y,1);
insample  = randsample(N,ceil(0.8*N)); %1:4000;%
Yin       = Y(insample,:);
Xin       = X(insample,:);
% standardize income
[Xin1,mXin1,sXin1] = zscore(Xin(:,1));
Xin(:,1)           = Xin1;
%
Xw        = Xin(:,1:10);
Xd        = Xin(:,11:end);
outsample = setdiff(1:N,insample);
Yout      = Y(outsample,:);
Xout      = X(outsample,:);
% standardize income out
Xout(:,1) = (Xout(:,1)-mXin1)/sXin1;
%
kappa     = Yin-0.5;
%betamle = mnrfit(X(:,2:end),[Y(:,2:end) Y(:,1)]);
% -------------------------------------------------------------------------
end