function [alphadgp,betadgp,betamle,betabin,Xw,Xd,X,Y,kappa,Yout,Xout,prob] = generate_data(Nin)
% -------------------------------------------------------------------------
Kw       = 4;
Kd       = 10;
K        = Kw+Kd;
N        = 10000+Nin; 
J        = 50;
% betadgp  = [zeros(K,J/2) [repelem(2*ones(Kw,1),1,J/2);...
%             repelem(repelem([0;2],1,J/2),Kd/2,1)]];
betadgp  = [zeros(K,J/5) [repelem(ones(Kw,1),1,4*J/5);...
            repelem(repelem([0 0 0 0;-2 -1 1 2; -2 1 -1 2; 2 -1 1 -2; 2 1 -1 -2],1,J/5),Kd/5,1)]];
alphadgp = 2*[0;rand(J-1,1)-0.5];

Xw       = randn(N,Kw);
p        = exp(Xw(:,1))./(1+exp(Xw(:,1)));
Xdall    = mnrnd(1,[(p/(Kd))*ones(1,Kd) 1-p]);
Xd       = Xdall(:,1:end-1);
X        = [Xw Xd];

expXB    = exp(ones(N,1)*alphadgp'+X*betadgp);
prob     = expXB./repmat(sum(expXB,2),1,J);
Y        = mnrnd(1,prob);
kappa    = Y-0.5;
% -------------------------------------------------------------------------
Yout = Y(Nin+1:end,:);
Xout = X(Nin+1:end,:);
Y    = Y(1:Nin,:);
X    = X(1:Nin,:);
Xw    = Xw(1:Nin,:);
Xd    = Xd(1:Nin,:);
kappa = kappa(1:Nin,:);
% -------------------------------------------------------------------------
betamle  = 0;%mnrfit(X,[Y(:,2:end) Y(:,1)]); % 
% -------------------------------------------------------------------------
betabin  = 0;%zeros(K+1,J-1);
% for j=2:J
%     indobs = (Y(:,j)+Y(:,1))==1;
%     betabin(:,j-1) = mnrfit(X(indobs,:),[Y(indobs,j) Y(indobs,1)]);
% end
% -------------------------------------------------------------------------

end