function alpha = smoothparam(mode,T)
%Computes smoothness parameter based on distribution of I given alpha and T
logst  = unsStirling1(T,T^(.75));
dlogst = diff(logst);
alpha  = ( exp(-dlogst(mode)) + exp(-dlogst(mode-1)) )/2;
end  
